## zmk 0.4.2

=== tests/Directory/Makefile ===
include z.mk

$(eval $(call ZMK.Import,Directories))

# Relative directory in the build tree
$(eval $(call ZMK.Expand,Directory,subdir/subsubdir))

# Sub-directory of a known directory.
$(eval $(call ZMK.Expand,Directory,$(libdir)/extra))

# Custom directory with duplicates and trailing slash.
$(eval $(call ZMK.Expand,Directory,/foo))
$(eval $(call ZMK.Expand,Directory,/foo))
$(eval $(call ZMK.Expand,Directory,/foo/))

# Custom directories with implicitly defined parents.
$(eval $(call ZMK.Expand,Directory,/custom/long/path))

# Custom directories with explicitly defined parents.
$(eval $(call ZMK.Expand,Directory,/))
$(eval $(call ZMK.Expand,Directory,/other))
$(eval $(call ZMK.Expand,Directory,/other/custom/))
$(eval $(call ZMK.Expand,Directory,/other/custom/path))

debug:: subdir/subsubdir $(addprefix $(DESTDIR),$(libdir)/extra /foo /custom/long/path /other/custom/path)

=== tests/Header/Makefile ===
include z.mk

$(eval $(call ZMK.Expand,Header,foo.h))
$(eval $(call ZMK.Expand,Header,include/bar.h))
froz.h.InstallDir = $(includedir)/froz
$(eval $(call ZMK.Expand,Header,froz.h))

=== tests/Program/Makefile ===
include z.mk

prog1.Sources = main.c
$(eval $(call ZMK.Expand,Program,prog1))
prog2.Sources = main.cpp
$(eval $(call ZMK.Expand,Program,prog2))
prog3.Sources = main.m
$(eval $(call ZMK.Expand,Program,prog3))
# Alternative C++ extensions
prog4.Sources = main.cxx
$(eval $(call ZMK.Expand,Program,prog4))
prog5.Sources = main.cc
$(eval $(call ZMK.Expand,Program,prog5))
# Source code can be in arbitrary tree structure.
prog6.Sources = src/main.c
$(eval $(call ZMK.Expand,Program,prog6))

=== tests/Symlink/Makefile ===
include z.mk

name.InstallDir = /some/path
name.SymlinkTarget=target
$(eval $(call ZMK.Expand,Symlink,name))

subdir/name.InstallDir = /other/path
subdir/name.SymlinkTarget=../target
$(eval $(call ZMK.Expand,Symlink,subdir/name))

=== debian/changelog ===
zmk (0.4.2-2) unstable; urgency=medium

  * no change pure source upload

 -- Michael Vogt <michael.vogt@ubuntu.com>  Tue, 02 Feb 2021 20:18:16 +0100

zmk (0.4.2-1) unstable; urgency=medium

  * Initial release. (Closes: #959105)

 -- Zygmunt Krynicki <me@zygoon.pl>  Mon, 28 Dec 2020 19:34:48 +0100

=== debian/rules ===
#!/usr/bin/make -f
export prefix=/usr

override_dh_auto_test:
	# Unset prefix set above as well as the Debian's hardening flags as they
	# interfere with the canned output measured by "make -n" style tests used
	# by zmk. Note that the test does not actually compile any software, just
	# checks the set of build system commands issued.
	unset prefix CFLAGS CXXFLAGS OBJCFLAGS OBJCXXFLAGS CPPFLAGS LDFLAGS && dh_auto_test

%:
	dh $@ --buildsystem=makefile

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/zmk_v?(\d\S*)\.tar\.gz/zmk-\$1\.tar\.gz/,\
pgpsigurlmangle=s/\.tar\.gz/\.tar\.gz\.asc/ \
  https://github.com/zyga/zmk/releases/latest .*/zmk_v?(\d\S+)\.tar\.gz

## zmk 0.5

=== debian/changelog ===
zmk (0.5-2) unstable; urgency=medium

  * Drop workaround make distclean bug

 -- Zygmunt Krynicki <me@zygoon.pl>  Mon, 08 Feb 2021 00:21:34 +0100

zmk (0.5-1) unstable; urgency=medium

  * Do not ship .log files in zmk-doc examples, closes: #981571
  * Override dh_auto_clean to improve build experience
  * Update uscan to account for new tarball name
  * Enable pristine-tar and signatures by default
  * New upstream version 0.5

 -- Zygmunt Krynicki <me@zygoon.pl>  Sun, 07 Feb 2021 22:55:30 +0100

## zmk 0.5.1

=== examples/hello-c/Makefile ===
include z.mk                                            # Include the zmk library

hello.Sources = hello.c                                 # Define the source files to compile into hello
$(eval $(call ZMK.Expand,Program,hello))                # Expand template for programs with the name hello

=== examples/hello-cpp/Makefile ===
include z.mk                                            # Include the zmk library

hello.Sources = hello.cpp                               # Define the source files to compile into hello
$(eval $(call ZMK.Expand,Program,hello))                # Expand template for programs with the name hello

=== examples/hello-objc/Makefile ===
include z.mk                                            # Include the zmk library

hello.Sources = hello.m                                 # Define the source files to compile into hello
$(eval $(call ZMK.Expand,Program,hello))                # Expand template for programs with the name hello

=== examples/libhello-c/Makefile ===
include z.mk                                            # Include the zmk library

$(eval $(call ZMK.Expand,Header,hello.h))               # Expand template for header files with the name hello.h

$(eval $(call ZMK.Import,Toolchain))                    # Import module "toolchain" to know about shared library types

libhello.a.Sources = hello.c                            # Define the source files to compile into libhello.a
$(eval $(call ZMK.Expand,Library.A,libhello.a))         # Expand template for static libraries with the name libhello.a

ifeq ($(Toolchain.CC.ImageFormat),ELF)                  # If the C compiler is producing ELF files then ...
libhello.so.1.Sources = hello.c                         # Define the source files to compile into libhello.so.1
libhello.so.1.VersionScript =                           # Indicate that we don't have a version script for this library
$(eval $(call ZMK.Expand,Library.So,libhello.so.1))     # Expand template for .so shared libraries with the name libhello.so.1
endif                                                   # End the if statement opened earlier

ifeq ($(Toolchain.CC.ImageFormat),Mach-O)               # If the C compiler is producing Mach-O files then ...
libhello.1.dylib.Sources = hello.c                      # Define the source files to compile into libhello.1.dylib
libhello.1.dylib.ExportList =                           # Indicate that we don't have an export list for this library
$(eval $(call ZMK.Expand,Library.DyLib,libhello.1.dylib))   # Expand template for .dylib shared libraries with the name libhello.1.dylib
endif                                                   # End the if statement opened earlier

=== examples/libhello-cpp/Makefile ===
include z.mk                                            # Include the zmk library

$(eval $(call ZMK.Expand,Header,hello.h))               # Expand template for header files with the name hello.h

$(eval $(call ZMK.Import,Toolchain))                    # Import module "toolchain" to know about shared library types

libhello.a.Sources = hello.cpp                          # Define the source files to compile into libhello.a
$(eval $(call ZMK.Expand,Library.A,libhello.a))         # Expand template for static libraries with the name libhello.a

ifeq ($(Toolchain.CXX.ImageFormat),ELF)                 # If the C++ compiler is producing ELF files then ...
libhello.so.1.Sources = hello.cpp                       # Define the source files to compile into libhello.so.1
libhello.so.1.VersionScript =                           # Indicate that we don't have a version script for this library
$(eval $(call ZMK.Expand,Library.So,libhello.so.1))     # Expand template for .so shared libraries with the name libhello.so.1
endif                                                   # End the if statement opened earlier

ifeq ($(Toolchain.CXX.ImageFormat),Mach-O)              # If the C++ compiler is producing Mach-O files then ...
libhello.1.dylib.Sources = hello.cpp                    # Define the source files to compile into libhello.1.dylib
libhello.1.dylib.ExportList =                           # Indicate that we don't have an export list for this library
$(eval $(call ZMK.Expand,Library.DyLib,libhello.1.dylib))   # Expand template for .dylib shared libraries with the name libhello.1.dylib
endif                                                   # End the if statement opened earlier

=== examples/libhello-objc/Makefile ===
include z.mk                                            # Include the zmk library

$(eval $(call ZMK.Expand,Header,hello.h))               # Expand template for header files with the name hello.h

$(eval $(call ZMK.Import,Toolchain))                    # Import module "toolchain" to know about shared library types

libhello.a.Sources = hello.m                            # Define the source files to compile into libhello.a
$(eval $(call ZMK.Expand,Library.A,libhello.a))         # Expand template for static libraries with the name libhello.a

ifeq ($(Toolchain.CC.ImageFormat),ELF)                  # If the C compiler is producing ELF files then ...
libhello.so.1.Sources = hello.m                         # Define the source files to compile into libhello.so.1
libhello.so.1.VersionScript =                           # Indicate that we don't have a version script for this library
$(eval $(call ZMK.Expand,Library.So,libhello.so.1))     # Expand template for .so shared libraries with the name libhello.so.1
endif                                                   # End the if statement opened earlier

ifeq ($(Toolchain.CC.ImageFormat),Mach-O)               # If the C compiler is producing Mach-O files then ...
libhello.1.dylib.Sources = hello.m                      # Define the source files to compile into libhello.1.dylib
libhello.1.dylib.ExportList =                           # Indicate that we don't have an export list for this library
$(eval $(call ZMK.Expand,Library.DyLib,libhello.1.dylib))   # Expand template for .dylib shared libraries with the name libhello.1.dylib
endif                                                   # End the if statement opened earlier

=== examples/script/Makefile ===
include z.mk                                            # Include the zmk library

$(eval $(call ZMK.Expand,Script,hello.sh))              # Expand template for scripts with the name hello

=== examples/true_false/Makefile ===
include z.mk                                            # Include the zmk library

true.Sources = true_false.c                             # Define the source files to compile into true
$(eval $(call ZMK.Expand,Program,true))                 # Expand template for programs with the name true
true$(exe): CPPFLAGS += -DEXIT_CODE=EXIT_SUCCESS        # Pass macro definition when compiling true

false.Sources = true_false.c                            # Define the source files to compile into false
$(eval $(call ZMK.Expand,Program,false))                # Expand template for programs with the name false
false$(exe): CPPFLAGS += -DEXIT_CODE=EXIT_FAILURE       # Pass macro definition when compiling false

=== tests/Configure/Makefile ===
NAME=test

include z.mk

$(eval $(call ZMK.Import,Configure))

debug: ;

=== tests/Directories/Makefile ===
include z.mk

$(eval $(call ZMK.Import,Directories))

debug:: $(addprefix $(DESTDIR),$(Directories.POSIX))

=== tests/Header/Makefile ===
--- 
+++ 
@@ -1,5 +1,4 @@
 include z.mk
-
 $(eval $(call ZMK.Expand,Header,foo.h))
 $(eval $(call ZMK.Expand,Header,include/bar.h))
 froz.h.InstallDir = $(includedir)/froz

=== tests/HeaderGroup/Makefile ===
include z.mk

foobar.Headers = foo.h bar.h
$(eval $(call ZMK.Expand,HeaderGroup,foobar))

froz.InstallDir = $(includedir)/sub/dir
froz.Headers = froz.h
$(eval $(call ZMK.Expand,HeaderGroup,froz))

=== debian/changelog ===
zmk (0.5.1-2) unstable; urgency=medium

  * debian: Add autopkgtest support

 -- Zygmunt Krynicki <me@zygoon.pl>  Thu, 24 Jun 2021 09:40:52 +0200

zmk (0.5.1-1) unstable; urgency=medium

  * New upstream version 0.5.1

 -- Zygmunt Krynicki <me@zygoon.pl>  Wed, 23 Jun 2021 23:01:36 +0200

=== debian/control ===
Source: zmk
Section: devel
Priority: optional
Maintainer: Zygmunt Krynicki <me@zygoon.pl>
Standards-Version: 4.5.1
Homepage: https://github.com/zyga/zmk
Build-Depends: debhelper-compat (= 13)
Vcs-Git: https://salsa.debian.org/zyga-guest/zmk.git
Vcs-Browser: https://salsa.debian.org/zyga-guest/zmk
Rules-Requires-Root: no

Package: zmk
Section: libs
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, make
Description: collection of reusable Makefiles
 Collection of makefiles implementing a system similar to autotools, but
 without the generated files that make understanding system behaviour harder.
 .
 Highlights include:
 .
  - Describe programs, test programs, static libraries, shared libraries,
    development headers, manual pages and more
  - Use familiar targets like "all", "check", "install" and "clean"
  - Works out of the box on popular distributions of Linux and MacOS
  - Friendly to distribution packaging expecting autotools
  - Compile natively with gcc, clang, tcc or the open-watcom compilers
  - Cross compile with gcc and open-watcom
  - Efficient and incremental, including the install target

Package: zmk-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: collection of reusable Makefiles (manual pages)
 Collection of makefiles implementing a system similar to autotools, but
 without the generated files that make understanding system behaviour harder.
 .
 Highlights include:
 .
  - Describe programs, test programs, static libraries, shared libraries,
    development headers, manual pages and more
  - Use familiar targets like "all", "check", "install" and "clean"
  - Works out of the box on popular distributions of Linux and MacOS
  - Friendly to distribution packaging expecting autotools
  - Compile natively with gcc, clang, tcc or the open-watcom compilers
  - Cross compile with gcc and open-watcom
  - Efficient and incremental, including the install target
 .
 This package contains the manual pages for zmk.

=== debian/rules ===
--- 
+++ 
@@ -8,5 +8,20 @@
 	# checks the set of build system commands issued.
 	unset prefix CFLAGS CXXFLAGS OBJCFLAGS OBJCXXFLAGS CPPFLAGS LDFLAGS && dh_auto_test
 
+override_dh_installexamples:
+	# Install examples except for the log files, which are a left-over from
+	# exercising the examples by the test suite.
+	dh_installexamples -X .log
+
+override_dh_auto_clean:
+	# Remove log files created by the build process.
+	find . -name '*.log' -delete
+	# Remove generated configuration files used by the test process.
+	find tests/Configure -name 'config.*.mk' -delete
+	# Remove the generated configure script used by the test process.
+	find tests/Configure -name 'configure' -delete
+	# Run the regular clean logic
+	dh_auto_clean
+
 %:
 	dh $@ --buildsystem=makefile

=== debian/tests/control ===
Tests: build-examples
Depends: zmk, gcc, g++, gobjc, gobjc++

Tests: build-examples-with-clang
Depends: zmk, clang

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/zmk-v?(\d\S*)\.tar\.gz/zmk-\$1\.tar\.gz/,\
pgpsigurlmangle=s/\.tar\.gz/\.tar\.gz\.asc/ \
  https://github.com/zyga/zmk/releases/latest .*/zmk-v?(\d\S+)\.tar\.gz

## zmk glovebox-0.1.0

=== Makefile ===
.PHONY: test test-fast test-integration test-smoke test-full lint format fmt coverage setup clean docs docs-clean docs-serve view-docs build check-package publish publish-test docker-image docker-publish release tag-release help

help:
	@echo "Available commands:"
	@echo "  make test       - Run all tests"
	@echo "  make test-fast  - Run fast unit tests only (< 5 min)"
	@echo "  make test-integration - Run integration tests (< 15 min)"
	@echo "  make test-smoke - Run smoke tests (< 2 min)"
	@echo "  make test-full  - Run comprehensive test suite with coverage"
	@echo "  make lint       - Run linting checks"
	@echo "  make format     - Format code and fix linting issues"
	@echo "  make coverage   - Run tests with coverage reporting"
	@echo "  make setup      - Create virtual environment and install dependencies"
	@echo "  make clean      - Clean build artifacts and coverage reports"
	@echo "  make docs       - Build documentation with MkDocs"
	@echo "  make docs-clean - Clean documentation build artifacts"
	@echo "  make docs-serve - Serve documentation with live reload"
	@echo "  make view-docs  - Instructions for viewing documentation"
	@echo "  make build      - Build package for distribution"
	@echo "  make check-package - Check package metadata and readiness"
	@echo "  make publish    - Build and publish package to PyPI"
	@echo "  make publish-test - Build and publish package to TestPyPI"
	@echo "  make docker-image - Build glovebox docker image with version tag"
	@echo "  make docker-publish - Build and publish docker image to registries"
	@echo "  make tag-release - Create and push git tag for release"
	@echo "  make release    - Full release: tag, build, publish to PyPI and Docker"

test: test-fast

test-fast:
	./scripts/test-fast.sh

test-integration:
	./scripts/test-integration.sh

test-smoke:
	./scripts/test-smoke.sh

test-full:
	./scripts/test-full.sh

lint:
	uv run scripts/lint.sh

format:
	uv run scripts/format.sh
fmt: format

coverage:
	uv run scripts/coverage.sh

setup:
	./scripts/setup.sh

clean:
	rm -rf build/ htmlcov/ .coverage .pytest_cache/ *.egg-info/ dist/ site/

docs:
	uv run mkdocs build

docs-clean:
	rm -rf site/

docs-serve:
	uv run mkdocs serve

view-docs:
	@echo "To view documentation:"
	@echo "1. Run 'make docs' to build"
	@echo "2. Open site/index.html in your browser"
	@echo "Or run 'make docs-serve' for live preview"

build:
	./scripts/build.sh

check-package:
	./scripts/check-package.sh

publish: build
	@echo "Publishing to PyPI..."
	@echo "WARNING: This will publish to the live PyPI repository!"
	@echo "Make sure you want to proceed with this release."
	@read -p "Continue? (y/N): " confirm && [ "$$confirm" = "y" ] || exit 1
	uv publish

publish-test: build
	@echo "Publishing to TestPyPI..."
	uv publish --index-url https://test.pypi.org/legacy/

docker-image:
	$(eval VERSION := $(shell uv run python -c 'import glovebox; print(glovebox.__version__.replace("+", "-").replace("/", "-"))'))
	@echo "Building Glovebox Docker image version $(VERSION)..."
	docker buildx build --platform linux/amd64,linux/arm64 -t glovebox/glovebox:$(VERSION) -t glovebox/glovebox:latest .
	@echo "✓ Docker image built: glovebox/glovebox:$(VERSION)"

docker-publish: docker-image
	$(eval VERSION := $(shell uv run python -c 'import glovebox; print(glovebox.__version__.replace("+", "-").replace("/", "-"))'))
	@echo "Publishing Docker images to registries..."
	@echo "Publishing to Docker Hub..."
	docker push glovebox/glovebox:$(VERSION)
	docker push glovebox/glovebox:latest
	@echo "Publishing to GitHub Container Registry..."
	docker tag glovebox/glovebox:$(VERSION) ghcr.io/$(shell git config --get remote.origin.url | sed 's/.*github.com[:/]\([^.]*\).*/\1/' | tr '[:upper:]' '[:lower:]')/glovebox:$(VERSION)
	docker tag glovebox/glovebox:latest ghcr.io/$(shell git config --get remote.origin.url | sed 's/.*github.com[:/]\([^.]*\).*/\1/' | tr '[:upper:]' '[:lower:]')/glovebox:latest
	docker push ghcr.io/$(shell git config --get remote.origin.url | sed 's/.*github.com[:/]\([^.]*\).*/\1/' | tr '[:upper:]' '[:lower:]')/glovebox:$(VERSION)
	docker push ghcr.io/$(shell git config --get remote.origin.url | sed 's/.*github.com[:/]\([^.]*\).*/\1/' | tr '[:upper:]' '[:lower:]')/glovebox:latest
	@echo "✓ Docker images published successfully"

tag-release:
	$(eval VERSION := $(shell uv run python -c 'import glovebox; print(glovebox.__version__)'))
	@echo "Creating release tag v$(VERSION)..."
	@if git tag -l | grep -q "^v$(VERSION)$$"; then \
		echo "Error: Tag v$(VERSION) already exists"; \
		exit 1; \
	fi
	@echo "Current version: $(VERSION)"
	@read -p "Create and push tag v$(VERSION)? (y/N): " confirm && [ "$$confirm" = "y" ] || exit 1
	git tag -a v$(VERSION) -m "Release version $(VERSION)"
	git push origin v$(VERSION)
	@echo "✓ Tag v$(VERSION) created and pushed"

release: test lint check-package
	$(eval VERSION := $(shell uv run python -c 'import glovebox; print(glovebox.__version__)'))
	@echo "=== Glovebox Release Process v$(VERSION) ==="
	@echo "This will:"
	@echo "  1. Create and push git tag v$(VERSION)"
	@echo "  2. Build and publish Python package to PyPI"
	@echo "  3. Build and publish Docker images"
	@echo ""
	@echo "Prerequisites checked:"
	@echo "  ✓ Tests passed"
	@echo "  ✓ Linting passed" 
	@echo "  ✓ Package metadata validated"
	@echo ""
	@read -p "Proceed with full release? (y/N): " confirm && [ "$$confirm" = "y" ] || exit 1
	$(MAKE) tag-release
	@echo "Waiting for GitHub Actions to complete..."
	@echo "The release workflow will automatically:"
	@echo "  - Build and publish to PyPI"
	@echo "  - Build and publish Docker images"
	@echo "  - Create GitHub release with changelog"
	@echo ""
	@echo "✓ Release process initiated!"
	@echo "Monitor progress at: https://github.com/$(shell git config --get remote.origin.url | sed 's/.*github.com[:/]\([^.]*\).*/\1/')/actions"

# Legacy docker build for ZMK toolchain (kept for compatibility)
docker-zmk-toolchain:
	$(eval VERSION := $(shell uv run python -c 'import glovebox; print(glovebox.__version__.replace("+", "-").replace("/", "-"))'))
	docker buildx build --build-arg BUILDTIME=$(shell date +%s) -t glove80-zmk-config-docker:$(VERSION) -f keyboards/glove80/toolchain/Dockerfile keyboards/glove80/toolchain
